setup-ipsec-vpn/extras/vpnupgrade_Libreswan.sh

128 lines
3.5 KiB
Bash
Raw Normal View History

2016-01-08 10:03:56 +01:00
#!/bin/sh
#
2016-04-21 00:31:29 +02:00
# Script to upgrade Libreswan on Ubuntu and Debian
2016-01-08 10:03:56 +01:00
#
2016-01-25 17:38:07 +01:00
# Copyright (C) 2016 Lin Song
2016-01-08 10:03:56 +01:00
#
# This work is licensed under the Creative Commons Attribution-ShareAlike 3.0
# Unported License: http://creativecommons.org/licenses/by-sa/3.0/
#
# Attribution required: please include my name in any derivative and let me
# know how you have improved it!
# Check https://libreswan.org and update version number if necessary
2016-04-06 06:51:54 +02:00
SWAN_VER=3.17
2016-01-08 10:03:56 +01:00
2016-01-21 18:50:35 +01:00
### Do not edit below this line
2016-04-21 00:31:29 +02:00
os_type="$(lsb_release -si 2>/dev/null)"
if [ "$os_type" != "Ubuntu" ] && [ "$os_type" != "Debian" ]; then
echo "This script only supports Ubuntu or Debian systems."
2016-01-08 10:03:56 +01:00
exit 1
fi
2016-01-30 20:12:15 +01:00
if [ -f /proc/user_beancounters ]; then
2016-01-19 08:32:22 +01:00
echo "This script does NOT support OpenVZ VPS."
exit 1
fi
2016-01-08 10:03:56 +01:00
if [ "$(id -u)" != 0 ]; then
2016-04-21 00:31:29 +02:00
echo "Script must be run as root. Try 'sudo sh $0'"
2016-01-08 10:03:56 +01:00
exit 1
fi
2016-01-13 06:05:16 +01:00
/usr/local/sbin/ipsec --version 2>/dev/null | grep -qs "Libreswan"
2016-01-08 10:03:56 +01:00
if [ "$?" != "0" ]; then
2016-04-21 00:31:29 +02:00
echo "This upgrade script requires Libreswan already installed."
2016-01-08 10:03:56 +01:00
exit 1
fi
2016-01-30 20:12:15 +01:00
/usr/local/sbin/ipsec --version 2>/dev/null | grep -qs "Libreswan $SWAN_VER"
2016-01-08 10:03:56 +01:00
if [ "$?" = "0" ]; then
2016-04-21 00:31:29 +02:00
echo "You already have Libreswan version $SWAN_VER installed! "
2016-01-08 10:03:56 +01:00
echo
printf "Do you wish to continue anyway? [y/N] "
read -r response
2016-01-08 10:03:56 +01:00
case $response in
[yY][eE][sS]|[yY])
echo
;;
*)
echo "Aborting."
exit 1
;;
esac
fi
2016-01-18 19:37:09 +01:00
clear
2016-01-30 20:12:15 +01:00
echo "Welcome! This script will build and install Libreswan $SWAN_VER on your server."
2016-04-21 00:31:29 +02:00
echo "Additional packages required for Libreswan compilation will also be installed."
2016-04-22 18:54:14 +02:00
echo
2016-04-21 00:31:29 +02:00
echo "This is intended for use on servers running an older version of Libreswan."
2016-01-08 10:03:56 +01:00
echo "Your existing VPN configuration files will NOT be modified."
2016-04-22 18:54:14 +02:00
if [ "$(sed 's/\..*//' /etc/debian_version)" = "7" ]; then
2016-01-18 19:37:09 +01:00
echo
2016-04-22 18:54:14 +02:00
echo "IMPORTANT: Workaround required for Debian 7 (Wheezy)."
echo "See: https://gist.github.com/hwdsl2/5a769b2c4436cdf02a90"
2016-01-30 20:12:15 +01:00
echo "Continue only after you have completed the workaround."
2016-01-18 19:37:09 +01:00
fi
2016-01-08 10:03:56 +01:00
echo
printf "Do you wish to continue? [y/N] "
read -r response
2016-01-08 10:03:56 +01:00
case $response in
[yY][eE][sS]|[yY])
echo
echo "Please be patient. Setup is continuing..."
echo
;;
*)
echo "Aborting."
exit 1
;;
esac
# Create and change to working dir
mkdir -p /opt/src
2016-04-22 18:54:14 +02:00
cd /opt/src || exit 1
2016-01-08 10:03:56 +01:00
2016-01-21 18:50:35 +01:00
# Update package index and install Wget
2016-01-08 10:03:56 +01:00
export DEBIAN_FRONTEND=noninteractive
apt-get -y update
2016-01-21 18:50:35 +01:00
apt-get -y install wget
2016-01-08 10:03:56 +01:00
# Install necessary packages
apt-get -y install libnss3-dev libnspr4-dev pkg-config libpam0g-dev \
libcap-ng-dev libcap-ng-utils libselinux1-dev \
2016-04-22 18:52:33 +02:00
libcurl4-nss-dev flex bison gcc make \
2016-01-08 10:03:56 +01:00
libunbound-dev libnss3-tools libevent-dev
apt-get -y --no-install-recommends install xmlto
# Compile and install Libreswan
SWAN_FILE="libreswan-${SWAN_VER}.tar.gz"
2016-01-30 20:12:15 +01:00
SWAN_URL="https://download.libreswan.org/$SWAN_FILE"
wget -t 3 -T 30 -nv -O "$SWAN_FILE" "$SWAN_URL"
2016-04-22 18:54:14 +02:00
[ "$?" != "0" ] && { echo "Cannot download Libreswan source. Aborting."; exit 1; }
2016-01-30 20:12:15 +01:00
/bin/rm -rf "/opt/src/libreswan-$SWAN_VER"
2016-04-21 00:31:29 +02:00
tar xvzf "$SWAN_FILE" && /bin/rm -f "$SWAN_FILE"
2016-04-22 18:54:14 +02:00
cd "libreswan-$SWAN_VER" || { echo "Cannot enter Libreswan source dir. Aborting."; exit 1; }
2016-04-06 09:51:37 +02:00
# Workaround for Libreswan compile issues
cat > Makefile.inc.local <<EOF
WERROR_CFLAGS =
EOF
2016-01-08 10:03:56 +01:00
make programs && make install
2016-01-20 06:17:18 +01:00
# Restart IPsec service
2016-04-21 00:31:29 +02:00
service ipsec restart
2016-01-30 20:12:15 +01:00
# Check if Libreswan install was successful
/usr/local/sbin/ipsec --version 2>/dev/null | grep -qs "$SWAN_VER"
2016-04-22 18:54:14 +02:00
[ "$?" != "0" ] && { echo; echo "Libreswan $SWAN_VER failed to build. Aborting."; exit 1; }
2016-01-08 10:03:56 +01:00
echo
2016-04-21 00:31:29 +02:00
echo "Libreswan $SWAN_VER was installed successfully! "
echo
2016-01-08 10:03:56 +01:00
exit 0